/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_BUTTONICON_H__96A59F11_138A_4A2B_8CA4_CA561B212D33__INCLUDED_)
#define AFX_BUTTONICON_H__96A59F11_138A_4A2B_8CA4_CA561B212D33__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <shlobj.h>

struct ICONSETTINGS
{
	bool showIcon;
	bool bigIcon;
	string iconX;
	string iconY;
	int iconSize;

	COLORREF icon_hueColor;
	int icon_hueIntensity;
	int icon_luminanceIntensity;
	int icon_saturationIntensity;

	COLORREF icon_mixColor;
	int icon_mixIntensity;
};

class ButtonIcon  
{
public:

	ButtonIcon();
	virtual ~ButtonIcon();

	void configure(const string &uniquekey, const string &groupkey);
	void apply(HDC hDC, int x, int y, int width, int height, int buttonType, const string &iconPath, const HWND iconhWnd, const LPITEMIDLIST iconpidl, const string &DefaultIcon, bool useAlphaMap);

private:

	void subconfigure(const string &uniquetype, const string &grouptype, const string &prefixkey, ICONSETTINGS &workSettings, ICONSETTINGS &defaultSettings);

	ICONSETTINGS defaulticon;
	ICONSETTINGS title;
	ICONSETTINGS entry;
	ICONSETTINGS selentry;
	ICONSETTINGS folder;
	ICONSETTINGS selfolder;

	ICONSETTINGS pinned;
	string pinnedIconPath;
};

#endif // !defined(AFX_BUTTONICON_H__96A59F11_138A_4A2B_8CA4_CA561B212D33__INCLUDED_)
